
// Vettori

import java.util.Scanner;

public class Esempio1 {

	static Scanner tastiera;
	
	public static void main(String[] args) {
		// Inizializziamo lo scanner per leggere da tastiera.
		// Questo basta farlo una volta sola per tutto il programma.
		tastiera = new Scanner(System.in);
		
		// Chiedi all'utente un numero n, e poi chiedi n numeri.
		System.out.println("Quanti numeri vuoi inserire?");
		int n;
		n = tastiera.nextInt();
		
		// Il tipo int[] è il tipo "vettore di int".
		int[] v;
		v = new int[n];   // Allocazione di un vettore lungo n
		int i;
		for (i = 0 ; i < v.length ; i++) { // v.length è la lunghezza
			System.out.println("Inserisci il numero " + i + ":");
			// v[i] è l'i-esima componente del vettore.
			// Nota bene: gli indici vanno da 0 a n-1, e NON da 1 a n.
			v[i] = tastiera.nextInt();
		}
		
		// Stampa vettore
		for (i = 0 ; i < v.length ; i++) { // v.length è la lunghezza
			System.out.println("v[" + i + "] = " + v[i]);
		}
		
		// Esercizio 1.
		// Chiedete all'utente di inserire un vettore come sopra,
		// e poi stampate tutte le somme parziali, ovvero:
		// v[0]
		// v[0]+v[1]
		// v[0]+v[1]+v[2]
		// ecc.
		// Usate un singolo for(;;) per farlo.
		//
		// Bonus: memorizzate le somme parziali in un nuovo vettore.
		// Bonus: scrivete una funzione che restituisca il vettore delle
		// somme parziali.

		// Esercizio 2.
		// Chiedete all'utente di inserire due vettori di interi
		// della stessa lunghezza. Create quindi un terzo vettore con
		// la somma dei primi due, e stampate il contenuto.
		//
		// Bonus: provate a farlo usando delle funzioni opportune, 
		// dividendo il codice in parti riusabili.

		// Esercizio 3.
		// Dato un vettore di interi, si calcoli se è ordinato in
		// modo crescente.
	}
	
}
