
// Vettori

import java.util.Scanner;

public class Esempio1Sol {

	static Scanner tastiera;
	
	static int[] leggiVettore(int len) {
		int[] v;
		v = new int[len];
		int i;
		for (i = 0 ; i < len ; i++) {
			System.out.println("Inserisci il numero " + i + ":");
			v[i] = tastiera.nextInt();	
		}
		return v;
	}

	static int[] sommaVettori(int[] v1, int[] v2) {
		int[] res;
		res = new int[v1.length];
		int i;
		for (i = 0 ; i < v1.length ; i++) {
			res[i] = v1[i] + v2[i];	
		}
		return res;
	}
	
	static void stampaVettore(int[] v) {
		int i;
		for (i = 0 ; i < v.length ; i++) {
			System.out.println("v[" + i + "] = " + v[i]);
		}	
	}
	
	
	public static void main(String[] args) {
		// Inizializziamo lo scanner per leggere da tastiera.
		// Questo basta farlo una volta sola per tutto il programma.
		tastiera = new Scanner(System.in);
		
		// Chiedi all'utente un numero n, e poi chiedi n numeri.
		System.out.println("Quanti numeri vuoi inserire?");
		int n;
		n = tastiera.nextInt();
		
		// Il tipo int[] è il tipo "vettore di int".
		int[] v;
		v = new int[n];   // Allocazione di un vettore lungo n
		int i;
		for (i = 0 ; i < v.length ; i++) { // v.length è la lunghezza
			System.out.println("Inserisci il numero " + i + ":");
			// v[i] è l'i-esima componente del vettore.
			// Nota bene: gli indici vanno da 0 a n-1, e NON da 1 a n.
			v[i] = tastiera.nextInt();
		}
		
		// Stampa vettore
		for (i = 0 ; i < v.length ; i++) { // v.length è la lunghezza
			System.out.println("v[" + i + "] = " + v[i]);
		}
		
		// Esercizio 1.
		// Chiedete all'utente di inserire un vettore come sopra,
		// e poi stampate tutte le somme parziali, ovvero:
		// v[0]
		// v[0]+v[1]
		// v[0]+v[1]+v[2]
		// ecc.
		// Usate un singolo for(;;) per farlo.

		// Soluzione
		
		System.out.println("[Somme parziali] Quanti numeri vuoi inserire?");
		n = tastiera.nextInt();
		
		v = new int[n];
		for (i = 0 ; i < v.length ; i++) {
			System.out.println("Inserisci il numero " + i + ":");
			v[i] = tastiera.nextInt();
		}
		
		// Stampa le somme parziali
		int somma;
		somma = 0;
		for (i = 0 ; i < v.length ; i++) {
			somma = somma + v[i];
			System.out.println("v[0] + ... + v[" + i + "] = " + somma);
		}

		// Esercizio 2.
		// Chiedete all'utente di inserire due vettori di interi
		// della stessa lunghezza. Create quindi un terzo vettore con
		// la somma dei primi due, e stampate il contenuto.
		//
		// Bonus: provate a farlo usando delle funzioni opportune, 
		// dividendo il codice in parti riusabili
		
		// Soluzione
		
		System.out.println("[Somma di vettori] Quanti numeri vuoi inserire?");
		n = tastiera.nextInt();
		
		int[] v1;
		v1 = leggiVettore(n);
		int[] v2;
		v2 = leggiVettore(n);
		int[] v3;
		v3 = sommaVettori(v1, v2);
		System.out.println("La somma dei vettori è");
		stampaVettore(v3);
		
		
		// Esercizio 3.
		// Dato un vettore di interi, si calcoli se è ordinato in
		// modo crescente.
		
		boolean ordinato;
		ordinato = true;
		for (i = 0 ; i < v.length-1 ; i++) {
			if (v[i] > v[i+1]) {
				ordinato = false;
			}
		}
		if (ordinato) {
			System.out.println("Il vettore sotto è ordinato in modo crescente");
		} else {
			System.out.println("Il vettore sotto NON è ordinato in modo crescente");
		}
		stampaVettore(v);
	}

}
